<script setup lang="ts">
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SFooter from '@/components/layout/SFooter.vue'
    import { Ref, ref } from 'vue'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { CarlConfigurationInterventionApi } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationInterventionApi'
    import { CarlConfigurationIntervention } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationIntervention'
    import { carlConfigurationInterventionMapper } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/carlConfigurationIntervention/CarlConfigurationInterventionMapper'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { useRouter, useRoute } from 'vue-router'
    import SCarlConfigurationInterventionForm from '@/shared/administration/components/interventionServiceOffer/gmaoConfigurationIntervention/SCarlConfigurationInterventionForm.vue'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { z } from 'zod'
    import { isDefined } from '@/shared/helpers/types'

    const carlConfigurationIntervention: Ref<
        Partial<CarlConfigurationIntervention>
    > = ref({
        interventionCostCenterIdsFilter: [],
        useEquipmentCostCenterForInterventionCreation: true,
        directions: [],
        includeEquipementsChildrenWithType: [],
        carlAttributesPresetForInterventionCreation: {},
        carlRelationshipsPresetForInterventionCreation: {},
        carlAttributesPresetForDemandeInterventionCreation: {},
        carlRelationshipsPresetForDemandeInterventionCreation: {},
        actionTypesMap: {},
        photoAvantInterventionDoctypeId: 'IMG',
        gestionRecompletementActif: false,
    })

    const router = useRouter()
    const route = useRoute()
    const { getParentRoute } = useBreadcrumb()

    const existingCarlConfigurationInterventionIdToDuplicate = z
        .string()
        .optional()
        .parse(route.query.existingCarlConfigurationInterventionIdToDuplicate)

    const msal = useMsal()

    const carlConfigurationInterventionApi =
        new CarlConfigurationInterventionApi(msal)

    if (isDefined(existingCarlConfigurationInterventionIdToDuplicate)) {
        carlConfigurationInterventionApi
            .get(existingCarlConfigurationInterventionIdToDuplicate)
            .then((fetchedCarlConfigurationIntervention) => {
                carlConfigurationIntervention.value =
                    fetchedCarlConfigurationIntervention
            })
            .catch((error) => {
                emitSnackBar((<Error>error).message, 'error')
                router.push(getParentRoute())
            })
    }

    async function createCarlConfigurationIntervention() {
        try {
            const carlConfigurationInterventionDto =
                carlConfigurationInterventionMapper.toCreateDto(
                    carlConfigurationIntervention.value
                )
            await carlConfigurationInterventionApi.create(
                carlConfigurationInterventionDto
            )

            emitSnackBar(`Configuration Carl créé`, 'primary')
            router.push(getParentRoute())
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
            router.push(getParentRoute())
        }
    }
</script>

<template>
    <s-contextual-navbar
        page-title="Ajouter une configuration Carl d'intervention"
    ></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <s-carl-configuration-intervention-form
                v-model="carlConfigurationIntervention"
                :loading="carlConfigurationInterventionApi.isProcessing.value"
                @submit.prevent="createCarlConfigurationIntervention()"
            >
            </s-carl-configuration-intervention-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
